-- TestBench Template 

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE behavior OF testbench IS 

-- Component Declaration
        Component rom_writer
        PORT(
           CLK     : in std_logic;
           DI      : in std_logic;
           DO      : out std_logic;
           SEL     : in std_logic;

           DATA    : inout std_logic_vector(7 downto 0) bus;
           ADDR    : out std_logic_vector(20 downto 0);
           RDY     : in std_logic;
           RESET   : out std_logic;
           WE      : out std_logic;
           OE      : out std_logic;

           OSTATE   : out std_logic_vector(2 downto 0);
           OBITS    : out std_logic_vector(2 downto 0);

           XDI1    : in std_logic;
           XCK1    : out std_logic;
           XDO1    : out std_logic;
           XSEL1   : out std_logic;
           XDI2    : in std_logic;
           XCK2    : out std_logic;
           XDO2    : out std_logic;
           XSEL2   : out std_logic
                );
        END COMPONENT;

           signal CLK     : std_logic;
           signal DI      : std_logic;
           signal DO      : std_logic;
           signal SEL     : std_logic;

           signal DATA    : std_logic_vector(7 downto 0);
           signal ADDR    : std_logic_vector(20 downto 0);
           signal RDY     : std_logic;
           signal RESET   : std_logic;
           signal WE      : std_logic;
           signal OE      : std_logic;

           signal OSTATE    : std_logic_vector(2 downto 0);
           signal OBITS    : std_logic_vector(2 downto 0);

           signal XDI1    : std_logic;
           signal XCK1    : std_logic;
           signal XDO1    : std_logic;
           signal XSEL1   : std_logic;
           signal XDI2    : std_logic;
           signal XCK2    : std_logic;
           signal XDO2    : std_logic;
           signal XSEL2   : std_logic;

BEGIN

-- Component Instantiation
        uut: Component rom_writer PORT MAP(
                  CLK => CLK,
                  DI => DI,
                  DO => DO,
                  SEL => SEL,
                  DATA => DATA,
                  ADDR => ADDR,
                  RDY => RDY,
                  RESET => RESET,
                  WE => WE,
                  OE => OE,
                  OSTATE => OSTATE,
                  OBITS => OBITS,
                  XDI1 => XDI1,
                  XCK1 => XCK1,
                  XDO1 => XDO1,
                  XSEL1 => XSEL1,
                  XDI2 => XDI2,
                  XCK2 => XCK2,
                  XDO2 => XDO2,
                  XSEL2 => XSEL2

        );


--  Test Bench Statements
   tb : PROCESS
   BEGIN

   DATA <= transport (others => 'Z');
   SEL <= transport '1';
   DI <= transport '0';
   for I in 0 to 3 loop
           CLK <= transport '1';
           WAIT FOR 80 ns;
           CLK <= transport '0';
           WAIT FOR 80 ns;
   end loop;
   SEL <= transport '0';
   WAIT FOR 160 ns;

   DI <= transport '0';
   CLK <= transport '1';
   WAIT FOR 80 ns;
   CLK <= transport '0';
   WAIT FOR 80 ns;

   DI <= transport '0';
   CLK <= transport '1';
   WAIT FOR 80 ns;
   CLK <= transport '0';
   WAIT FOR 80 ns;

   DI <= transport '0';
   CLK <= transport '1';
   WAIT FOR 80 ns;
   CLK <= transport '0';
   WAIT FOR 80 ns;

   DI <= transport '0';
   CLK <= transport '1';
   WAIT FOR 80 ns;
   CLK <= transport '0';
   WAIT FOR 80 ns;

   DI <= transport '0';
   CLK <= transport '1';
   WAIT FOR 80 ns;
   CLK <= transport '0';
   WAIT FOR 80 ns;

   DI <= transport '0';
   CLK <= transport '1';
   WAIT FOR 80 ns;
   CLK <= transport '0';
   WAIT FOR 80 ns;

   DI <= transport '0';
   CLK <= transport '1';
   WAIT FOR 80 ns;
   CLK <= transport '0';
   WAIT FOR 80 ns;

   DI <= transport '0';
   CLK <= transport '1';
   WAIT FOR 80 ns;
   CLK <= transport '0';
   WAIT FOR 80 ns;

   for I in 0 to 23 loop
         DI <= transport '1';
         CLK <= transport '1';
         WAIT FOR 80 ns;
         CLK <= transport '0';
         WAIT FOR 80 ns;
   end loop;

   DI <= transport '0';
   CLK <= transport '1';
   WAIT FOR 80 ns;
   CLK <= transport '0';
   WAIT FOR 80 ns;

   DI <= transport '0';
   CLK <= transport '1';
   WAIT FOR 80 ns;
   CLK <= transport '0';
   WAIT FOR 80 ns;

   DI <= transport '0';
   CLK <= transport '1';
   WAIT FOR 80 ns;
   CLK <= transport '0';
   WAIT FOR 80 ns;

   DI <= transport '0';
   CLK <= transport '1';
   WAIT FOR 80 ns;
   CLK <= transport '0';
   WAIT FOR 80 ns;

   DI <= transport '0';
   CLK <= transport '1';
   WAIT FOR 80 ns;
   CLK <= transport '0';
   WAIT FOR 80 ns;

   DI <= transport '0';
   CLK <= transport '1';
   WAIT FOR 80 ns;
   CLK <= transport '0';
   WAIT FOR 80 ns;

   DI <= transport '1';
   CLK <= transport '1';
   WAIT FOR 80 ns;
   CLK <= transport '0';
   WAIT FOR 80 ns;

   DI <= transport '1';
   CLK <= transport '1';
   WAIT FOR 80 ns;
   CLK <= transport '0';
   WAIT FOR 80 ns;

   DI <= transport '0';
   DATA <= transport "01011100";
   for I in 0 to 7 loop
         CLK <= transport '1';
         WAIT FOR 80 ns;
         CLK <= transport '0';
         WAIT FOR 80 ns;
   end loop;
   DATA <= transport (others => 'Z');
   for I in 0 to 7 loop
         CLK <= transport '1';
         WAIT FOR 80 ns;
         CLK <= transport '0';
         WAIT FOR 80 ns;
   end loop;
   DATA <= transport "10101010";
   for I in 0 to 7 loop
         CLK <= transport '1';
         WAIT FOR 80 ns;
         CLK <= transport '0';
         WAIT FOR 80 ns;
   end loop;
   DATA <= transport (others => 'Z');
   for I in 0 to 7 loop
         CLK <= transport '1';
         WAIT FOR 80 ns;
         CLK <= transport '0';
         WAIT FOR 80 ns;
   end loop;
   DATA <= transport "00111100";
   for I in 0 to 7 loop
         CLK <= transport '1';
         WAIT FOR 80 ns;
         CLK <= transport '0';
         WAIT FOR 80 ns;
   end loop;
   DATA <= transport (others => 'Z');
   for I in 0 to 7 loop
         CLK <= transport '1';
         WAIT FOR 80 ns;
         CLK <= transport '0';
         WAIT FOR 80 ns;
   end loop;


   DI <= transport '1';
   for I in 1 to 200 loop
           CLK <= transport '1';
           WAIT FOR 80 ns;
           CLK <= transport '0';
           WAIT FOR 80 ns;
   end loop;
   SEL <= transport '1';

      wait; -- will wait forever
   END PROCESS;
--  End Test Bench 

END;
